package raytracer.tracers;

import raytracer.utilities.*;
import raytracer.world.World;

//Copyright (C) Helen Hu 2011.
//based on C++ code from Ray Tracing from the Ground Up, by Kevin Suffern 
//This Java code is for non-commercial purposes only.
//This Java code is licensed under the GNU General Public License Version 2.
//See the file COPYING.txt for the full license.


public class MultipleObjects extends Tracer {

	// -------------------------------------------------------------------- default constructor

	public MultipleObjects() {
		super();
	}
	
	// -------------------------------------------------------------------- constructor
			
	public MultipleObjects(World world) {
		super(world);
	}



	// -------------------------------------------------------------------- trace_ray

	public RGBColor trace_ray(Ray ray) {
		ShadeRec sr = world_ptr.hit_bare_bones_objects(ray); 
			
		if (sr.hit_an_object)   
			return (sr.color);   
		else
			return (world_ptr.background_color);
	}

	// -------------------------------------------------------------------- trace_ray

	public RGBColor trace_ray(Ray ray, int depth) {
		return trace_ray(ray);
	}

}
